#!/usr/bin/env python2

import sys
sys.path.append('/usr/share/zope')
sys.path.append('/usr/share/zope/lib/python')

import os, ZEO.ClientStorage, ZServer
from ZODB import DB

zeo_conn = '/var/zeo/var/zeo.soc'  # Unix-style Socket
#zeo_conn = ('localhost', 6333)     # TCP-style Socket

conn = DB(ZEO.ClientStorage.ClientStorage(zeo_conn, storage='1')).open(version='')
root = conn.root()

print "root", `root.items()`

print "Database Name: %s" % conn.db().getName()
print "Database Size: %d" % conn.db().getSize()
print "Database Objs: %d" % conn.db().objectCount()

root['jeff'] = 'rush'
root['becky'] = 1

print "Undo Log:"
for u in conn.db().undoLog(first=0, last=-20, filter=None):
    print "\t%s" % `u`

conn.db().pack(t=None, days=0)

conn2 = DB(ZEO.ClientStorage.ClientStorage(zeo_conn, storage='2')).open()
root2 = conn2.root()

print "root2", `root2.items()`

print "Database2 Name: %s" % conn2.db().getName()
print "Database2 Size: %d" % conn2.db().getSize()
print "Database2 Objs: %d" % conn2.db().objectCount()

root2['mary'] = 'rush'
root2['jack'] = 1

print "TransactionID: ", get_transaction()._id
get_transaction().note('some memo about transaction')
get_transaction().setUser('jrush', path='/')
get_transaction().setExtendedInfo('someinfo', 'somevalue')
get_transaction().commit()

# Useful Database Methods:
#   conn.db().supportsUndo() -> boolean
#   conn.db().supportsVersions() -> boolean
#   conn.db().getName() -> {name of storage}
#   conn.db().getSize() -> {size of storage}
#   conn.db().objectCount() -> count
#   conn.db().pack(t=None, days=0) -> None
#   conn.root() -> {topmost object in database}

# Transaction Operations:
#   get_transaction().note('some memo about transaction')
#   get_transaction().setUser('nobody', path='/')
#   get_transaction().setExtendedInfo('someinfo', 'somevalue')
#   get_transaction().begin(info='/ jrush\tsome description', subtransaction=None)
#   get_transaction().commit(subtransacton=0)
#   get_transaction().abort(subtransaction=0)

# Undo Operations:
#   conn.db().undo(transactionid) -> None
#   conn.db().undoLog(first=0, last=-20, filter=None) -> ??? passed to storage

# Version Operations:
#   conn.getVersion() -> versionstringid
#   conn.db().abortVersion(version)
#   conn.db().commitVersion(source, destination=''):
#   conn.db().versionEmpty(version) -> ??? passed to storage
#   conn.db().versions(max=None) -> ??? passed to storage
#   conn.db().history(oid, version=None, size=1, filter=None) -> ??? passed to storage
