# This file tells the ZEO server the names, types and locations
# of object-databases to be served.  You can define just one
# or several.  The name of this python script is specified in
# the /var/zeo/start_zeo script and it is run automatically.
# You do not need to import or run it yourself.

from ZODB.FileStorage import FileStorage
db_file = FileStorage('var/data.fs', create=0, read_only=0, stop=None, quota=None)


# This storage provides for use of dbm files as storages that
# don't support versions or Undo.  This may be useful when implementing
# objects like hit counters that don't need or want to participate
# in undo or versions.

from ZODB.dbmStorage import gdbmStorage
db_gdbm = gdbmStorage('var/data.dbm', flag='w', mode=0660)

